/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Main Window
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
/**--------------------------------------------------------------------------
 **		EBhENXo^
 **------------------------------------------------------------------------*/
BOOL
n80_form::registerClass (
	HINSTANCE hinst,	// hInstance
	HICON	hicon,		//	ACR
	HCURSOR	hcursor,	//	J[\
	HBRUSH  hbr,		//	uV
	LPCTSTR	clsname)	//	NX
{
	WNDCLASSEX	wc;
	ATOM		awc;

	wc.cbSize		 = sizeof (wc);
	wc.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wc.lpfnWndProc   = n80_form::WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hinst;
	wc.hIcon         = hicon;
	wc.hCursor       = hcursor;
	wc.hbrBackground = hbr;
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = clsname;
	wc.hIconSm		 = NULL;

	awc = ::RegisterClassEx (&wc);
	return !awc ? FALSE : TRUE;
}
/**--------------------------------------------------------------------------
 **		Proxy WndProc
 **------------------------------------------------------------------------*/
LRESULT CALLBACK
n80_form::WndProc (HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	n80_form	*win;

	win = (n80_form *) ::GetWindowLong (hwnd, GWL_USERDATA);
	if (win == NULL)
		return  ::DefWindowProc (hwnd, msg, wp, lp);
	else
		return	win->defWndproc(hwnd, msg, wp, lp);
}
/**--------------------------------------------------------------------------
 **		Message Loop
 **------------------------------------------------------------------------*/
int
n80_form::messageLoop ()
{
	MSG			msg;

	while (::GetMessage (&msg, 0, 0, 0))
	{
		//if (::IsDialogMessage (msg.hwnd, &msg))
		//	continue;
		::TranslateMessage (&msg);
		::DispatchMessage (&msg);
	}
	return  (msg.wParam);
}
