//
//		IICCJ Class Library Ver 1.00
//		iiccj a
//
//		敪F  LFȂ  nrF95/NT  FC++
//		-----------------------------------------------
//		  	F	֐
//		NXF	
//		  I	F	vZXq[ṽǗ
//		File敪F	(.cpp)
//		쐬	F	{ mu
//
//		Rev		t			ύX_
//		-----	----------	----------------------------------------------
//		1.0.0	1998.03.21	
//
#include <windows.h>
#include <crtdbg.h>
#define  IICCJ_HEAP_FLAG	HEAP_NO_SERIALIZE | HEAP_ZERO_MEMORY

///////////////////////////////////////////////////////////////////////////////
// operator new overloaded
///////////////////////////////////////////////////////////////////////////////
void * _cdecl
operator new (size_t size)
{
	_RPT0 (_CRT_WARN, ">icj_memory :common new operator\n");
	return ::HeapAlloc (::GetProcessHeap (), 0, size);
}

///////////////////////////////////////////////////////////////////////////////
// operator delete overloaded
///////////////////////////////////////////////////////////////////////////////
void _cdecl
operator delete (void *ptr)
{
	BOOL	br;

	_RPT0 (_CRT_WARN, ">icj_memory :common delete operator\n");
	br = ::HeapFree (::GetProcessHeap (), 0, ptr);
	#ifdef _DEBUG
	if (!br)
		_RPT0 (_CRT_WARN, ">icj_memory delete:HeapFree API error.\n");
	#endif
}

///////////////////////////////////////////////////////////////////////////////
//	mہ^Ċmہ^[`
///////////////////////////////////////////////////////////////////////////////
void *
xmalloc (unsigned int size)
{
	return	::HeapAlloc (::GetProcessHeap (), IICCJ_HEAP_FLAG, size);
}

void *
xcalloc (unsigned int size, unsigned int count)
{
	size *= count;
	return	::HeapAlloc (::GetProcessHeap (), IICCJ_HEAP_FLAG, size);
}

void *
xrealloc (void *prevmem, unsigned int newsize)
{
	if (prevmem == NULL)
		return  NULL;

	return  ::HeapReAlloc (::GetProcessHeap (), IICCJ_HEAP_FLAG,
							prevmem, newsize);
}

void
xfree (void *mem)
{
	BOOL	br;

	if (mem == NULL)
		return;

	br = ::HeapFree (::GetProcessHeap (), 0, mem);
	#ifdef _DEBUG
	if (!br)
		_RPT0 (_CRT_WARN, ">icj_memory xfree:HeapFree API error.\n");
	#endif
}
